=== debian/changelog ===
molmodel (3.1.0-4.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:08:27 +0000

molmodel (3.1.0-4.1build1) noble; urgency=high

  * No change rebuild against libopenmm8.0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 25 Mar 2024 14:49:43 +0100

molmodel (3.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062945

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 20:17:19 +0000

molmodel (3.1.0-4) unstable; urgency=medium

  * Fix FTBFS with GCC-13 (Closes: #1037780)

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Jul 2023 04:50:25 -0400

molmodel (3.1.0-3) unstable; urgency=medium

  * Adapt upstream fix to restore compatibility with gemmi (Closes: #1037472)
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Wed, 21 Jun 2023 07:13:00 -0400

molmodel (3.1.0-2) unstable; urgency=medium

  * libopenmm-dev is a strict dependency.

 -- Andrius Merkys <merkys@debian.org>  Sun, 04 Dec 2022 03:39:42 -0500

molmodel (3.1.0-1) unstable; urgency=medium

  * New upstream release 3.1.0.
  * Adjust to soname bump.
  * Split off plugins package.
  * Install CMake and pkgconfig files.

 -- Andrius Merkys <merkys@debian.org>  Wed, 30 Nov 2022 08:17:20 -0500

molmodel (3.0.113.gd05a5b6-2) unstable; urgency=medium

  * Remove CMAKE_CXX_STANDARD setting (Closes: #1009402).
  * Bump copyright years.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Mon, 30 May 2022 09:08:42 -0400
